hdoj 3072 Intelligence System【求scc&&缩点】【求连通所有scc的最小花费】

Intelligence System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1904    Accepted Submission(s): 824

Problem Description

After a day, ALPCs finally complete their ultimate intelligence system, the purpose of it is of course for ACM ... ... 
Now, kzc_tc, the head of the Intelligence Department (his code is once 48, but now 0), is sudden obtaining important information from one Intelligence personnel. That relates to the strategic direction and future development of the situation of ALPC. So it need for emergency notification to all Intelligence personnel, he decides to use the intelligence system (kzc_tc inform one, and the one inform other one or more, and so on. Finally the information is known to all).
We know this is a dangerous work. Each transmission of the information can only be made through a fixed approach, from a fixed person to another fixed, and cannot be exchanged, but between two persons may have more than one way for transferring. Each act of the transmission cost Ci (1 <= Ci <= 100000), the total cost of the transmission if inform some ones in our ALPC intelligence agency is their costs sum. 
Something good, if two people can inform each other, directly or indirectly through someone else, then they belong to the same branch (kzc_tc is in one branch, too!). This case, it’s very easy to inform each other, so that the cost between persons in the same branch will be ignored. The number of branch in intelligence agency is no more than one hundred.
As a result of the current tensions of ALPC’s funds, kzc_tc now has all relationships in his Intelligence system, and he want to write a program to achieve the minimum cost to ensure that everyone knows this intelligence.
It‘s really annoying!

Input

There are several test cases. 
In each case, the first line is an Integer N (0< N <= 50000), the number of the intelligence personnel including kzc_tc. Their code is numbered from 0 to N-1. And then M (0<= M <= 100000), the number of the transmission approach.
The next M lines, each line contains three integers, X, Y and C means person X transfer information to person Y cost C.

Output

The minimum total cost for inform everyone.
Believe kzc_tc’s working! There always is a way for him to communicate with all other intelligence personnel.

Sample Input

3 3

0 1 100

1 2 50

0 2 100

3 3

0 1 100

1 2 50

2 1 100

2 2

0 1 50

0 1 100

Sample Output

150

100

50

题意:有N个人编号从0到N-1,给出M组关系<u,v,w>表示u联系v需要费用w(但不代表v联系u需要费用w)。若一个集合中 任意两个人可以互相联系(不管是直接联系的还是通过其他人间接联系的),那么在这个集合里面联系的费用可以忽略。现在你是编号0,问你联系到所有人的最小费用。题目保证至少有一组方案使得你可以联系到所有人。

题解:求出所有的scc,因为同一个scc中的人相互通知不需要花费,所以总花费是连接所有scc的花费

在缩点的过程同时更新连接scc所需要的最小花费   最后累加即可

#include<stdio.h>
#include<string.h>
#include<stack>
#include<algorithm>
#define MAX 100010
#define INF 0x3f3f3f
#include<vector>
using namespace std;
int n,m;
int head[MAX],ans;
int low[MAX],dfn[MAX];
int sccno[MAX];
int scccnt,dfsclock;
vector<int>scc[MAX];
vector<int>newmap[MAX];
stack<int>s;
int instack[MAX],money[MAX];
struct node
{
	int beg,end,next;
	int cost;
}edge[MAX];
void init()
{
	ans=0;
	memset(head,-1,sizeof(head));
}
void add(int beg,int end,int cost)
{
	edge[ans].beg=beg;
	edge[ans].end=end;
	edge[ans].cost=cost;
	edge[ans].next=head[beg];
	head[beg]=ans++;
}
void getmap()
{
	int a,b,c,i;
	while(m--)
	{
		scanf("%d%d%d",&a,&b,&c);
		add(a,b,c);
	}
}
void tarjan(int u)
{
	int i,v;
	s.push(u);
	instack[u]=1;
	low[u]=dfn[u]=++dfsclock;
	for(i=head[u];i!=-1;i=edge[i].next)
	{
		v=edge[i].end;
		if(!dfn[v])
		{
			tarjan(v);
			low[u]=min(low[u],low[v]);
		}
		else if(instack[v])
		    low[u]=min(low[u],dfn[v]);
	}
	if(low[u]==dfn[u])
	{
		scccnt++;
		while(1)
		{
			v=s.top();
			s.pop();
			instack[v]=0;
			sccno[v]=scccnt;
			if(v==u)
			break;
		}
	}
}
void find(int l,int r)
{
	memset(low,0,sizeof(low));
	memset(dfn,0,sizeof(dfn));
	memset(instack,0,sizeof(instack));
	memset(sccno,0,sizeof(sccno));
	dfsclock=scccnt=0;
	for(int i=l;i<=r;i++)
	{
		if(!dfn[i])
		    tarjan(i);
	}
}
void suodian()
{
	int i;
	for(i=1;i<=scccnt;i++)
	{
		newmap[i].clear();
		money[i]=INF;
	}
	for(i=0;i<ans;i++)
	{
		int u=sccno[edge[i].beg];
		int v=sccno[edge[i].end];
		if(u!=v)//u不等于v证明u和v不在同一个scc,则u-->v这条边是连接两个scc的边,
		{      //拿这条边和其他的可以连接这两个scc的边比较取最小值
			newmap[u].push_back(v);
			money[v]=min(edge[i].cost,money[v]);
		}
	}
}
void solve()
{
	int i,j;
	int sum=0;
	for(i=1;i<=scccnt;i++)
	{
		if(sccno[0]!=i)//0所在的scc不需要花费,因为消息就是从这里来的
		    sum+=money[i];
	}
	printf("%d\n",sum);
}
int main()
{
	while(scanf("%d%d",&n,&m)!=EOF)
	{
		init();
		getmap();
		find(0,n-1);
		suodian();
		solve();
	}
	return 0;
}

  

时间: 2024-10-22 11:44:19

hdoj 3072 Intelligence System【求scc&&缩点】【求连通所有scc的最小花费】的相关文章

HDU 3072 Intelligence System(强连通+最小树形图)

HDU 3072 Intelligence System 题目链接 题意:给定有向图,边有权值,求保留一些边,从一点出发,能传递到其他所有点的最小代价,保证有解 思路:先缩点,然后从入度为0的点作为起点(因为题目保证有解,所以必然有一个且只有一个入度为0的点),然后做一下最小树形图即可 代码: #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #includ

[tarjan+最小树形图] hdu 3072 Intelligence System

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=3072 Intelligence System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1479    Accepted Submission(s): 653 Problem Description After a day, ALP

hdu 3072 Intelligence System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2909    Accepted Submission(s): 1259 Problem Description After a day, ALPCs finally complete their ultimate intelligence system, the purpose of it

HDU——T 3072 Intelligence System

http://acm.hdu.edu.cn/showproblem.php?pid=3072 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2909    Accepted Submission(s): 1259 Problem Description After a day, ALPCs finally complete their

HDU - 3072 Intelligence System(强连通分量+类最小生成树)

题目大意:有一个人想要将消息告诉给所有人(在同一个强连通分量里面的人可以相互转告,费用为0),问所有人都知道消息的最小花费是多少 解题思路:求出所有的强连通分量,然后将其缩点,桥就是连接其中的边 因为是张连通图,所以只要求出每个强连通分量被通知的最小价值,然后累加即可 刚开始以为可以用最小生成树,但发现错了,假设求出了三个强连通分量了,分别标号为1,2,3 再给出桥 1-2,权值1,1-3权值5,3-2权值4 按最小生成树的话,得到的结果是5,然而并不是这样的,因为是有向边,所以3这个点是不会被

HDU 3072 Intelligence System (强连通+(贪心||树形图))

大意:在一个联通分量里面的边权值忽略不计,求缩点后的所有联通分量链接在一起的最小权值和. 思路:必然先缩点,最后得到的图为DAG,然后就是统计权值,对于那么到达当前的缩点可能有多个入度,所以选择最小的即可.最后避开起始点的dis[star] == inf.累加即可. #include<map> #include<queue> #include<cmath> #include<cstdio> #include<stack> #include<

HDU 3072 Intelligence System (强连通分量)

题目地址:HDU 3072 这题一开始理解错题目意思了..(不得不吐槽一下题目意思确实不好理解..)用的强连通+最小生成树做的...然后错了好多遍...sad..题目意思是从一个给定点向其他所有点通信的最少花费,那么入度为0的点肯定是那个给定点.然后对于其它点,枚举就好了.找一个到他花费最少的点的花费. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue&g

Intelligence System (hdu 3072 强联通缩点+贪心)

Intelligence System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1650    Accepted Submission(s): 722 Problem Description After a day, ALPCs finally complete their ultimate intelligence syste

HDU 3072--Intelligence System【SCC缩点新构图 &amp;&amp; 求连通所有SCC的最小费用】

Intelligence System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1859    Accepted Submission(s): 799 Problem Description After a day, ALPCs finally complete their ultimate intelligence syste